'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var SUFFIX_AGO = 'ago';
var SUFFIX_FROM_NOW = 'from now';
var UNITS = [{
  key: 'year',
  getter: 'getUTCFullYear',
  setter: 'setYear'
}, {
  key: 'month',
  getter: 'getMonth',
  setter: 'setMonth'
}, {
  key: 'day',
  getter: 'getDate',
  setter: 'setDate'
}, {
  key: 'hour',
  getter: 'getHours',
  setter: 'setHours'
}, {
  key: 'minute',
  getter: 'getMinutes',
  setter: 'setMinutes'
}, {
  key: 'second',
  getter: 'getSeconds',
  setter: 'setSeconds'
}];

var REGEXP = new RegExp('^([0-9]+)\\s(' + UNITS.map(function (unit) {
  return unit.key;
}).join('|') + ')s?\\s(' + SUFFIX_AGO + '|' + SUFFIX_FROM_NOW + ')$');

function parser(input) {
  var result = void 0;

  if (input) {
    var matches = input.match(REGEXP);

    if (input === 'now' || matches) {
      result = new Date();

      if (matches) {
        (function () {
          var _matches = _slicedToArray(matches, 4);

          var amount = _matches[1];
          var kind = _matches[2];
          var suffix = _matches[3];
          var _UNITS$filter$ = UNITS.filter(function (u) {
            return u.key === kind;
          })[0];
          var setter = _UNITS$filter$.setter;
          var getter = _UNITS$filter$.getter;


          if (suffix === SUFFIX_AGO) {
            result[setter](result[getter]() - parseInt(amount, 10));
          } else {
            result[setter](result[getter]() + parseInt(amount, 10));
          }
        })();
      }
    }
  }

  if (!result) {
    throw new Error('\'' + input + '\' it\'s an invalid date');
  }

  return result;
}

exports.default = parser;
module.exports = exports['default'];